#include <tiny2313.h>
#include <delay.h>
//#include <stdlib.h> //  itoa
//#include <ctype.h> 
// Standard Input/Output functions
#include <stdio.h> // putchar
// Declare your global variables here
     
interrupt [TIM1_COMPB] void timer1_compb_isr(void)
{
// Place your code here
}

interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{ 
}
// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
}

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port D initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;//        A  B
TCCR1B=0x00;//   64
TCNT1H=0x00; //   1
TCNT1L=0x00; //   1
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;//     A
OCR1AL=0x00;//     A
OCR1BH=0x00;//    B
OCR1BL=0x00;//    B

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00; //    A  1

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 19200
UCSRA=0x00;
UCSRB=0x18; //    
UCSRC=0x06;
UBRRH=0x00;
UBRRL=0x0C;

putchar(0x00);

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
#asm("sei")//  
while (1)
      { 
       //while ( !(UCSRA & (1<<UDRE)) ); //        
       PORTD=0x00; //   0 
       DDRD=0xFF;//            
       UCSRB=0x00; //    
       delay_ms(500);
       PORTD=0xFF; 
       delay_ms(500);
       PORTD=0x00;
       delay_ms(500);
       PORTD=0xFF;
       delay_ms(500);
       PORTD=0x00;  
       while(1){};
     
      }
}
